<?php
/*
    [123imagestock] (C)2006-2007 123imagestock Software. All Rights Reserved.
    This is NOT a freeware, use is subject to license terms
*/
class CategoryService
    {
    // database object
    var $_db   = null;
    var $error = null;
    var $table_prefix = null;

    function __construct($db, $table_prefix)
        {
        $this->_db         =$db;
        $this->table_prefix=$table_prefix;
        }

    public function getNum()
        {
        $sql   ="select count(*) as num from " . $this->table_prefix . "categories";
        $result=$this->_db->query($sql);
        $num   =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $num['num'];
        }

    public function checkAddForm($data)
        {
        $error=array();

        if (checkBlank($data['name']) or !checkIdName($data['name']))
            {
            $error['cat_name']=1;
            }

        return $error;
        }

    public function checkUpdateForm($data)
        {
        $error=array();

        if (checkBlank($data['name']) or !checkIdName($data['name']))
            {
            $error['cat_name']=1;
            }

        return $error;
        }

    public function save($data)
        {
        $cat_parent_id=$data['pcategory'];

        if (!$this->pcategoryContainName($cat_parent_id, $data['name']))
            {
            $cat_name       =$data['name'];
            $cat_description=$data['description'];
            $cat_order      ='';

            if ($data['order'] == "beginning")
                {
                $cat_order='0';
                $sql      ="update " . $this->table_prefix . "categories set cat_order = cat_order+1 where 

cat_parent_id=" . $cat_parent_id;
                $result   =$this->_db->query($sql);

                if ($result == false)
                    {
                    return false;
                    }
                }
            else if ($data['order'] == "end")
                {
                $sql   ="select max(cat_order) as max from " . $this->table_prefix . "categories where 

cat_parent_id=" . $cat_parent_id;
                $result=$this->_db->query($sql);
                $temp  =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
                $this->_db->free_result($result);

                if (!is_null($temp['max']))
                    {
                    $cat_order=$temp['max'] + 1;
                    }
                else
                    {
                    $cat_order='0';
                    }
                }
            else
                {
                $sql   ="select cat_order from " . $this->table_prefix . "categories where cat_id=" . $data['order'];
                $result=$this->_db->query($sql);
                $temp  =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
                $this->_db->free_result($result);
                $cat_order=$temp['cat_order'] + 1;
                $sql      ="update " . $this->table_prefix . "categories set cat_order = cat_order+1 where 
cat_parent_id=" . $cat_parent_id . " and cat_order>" . $temp['cat_order'];
                $result   =$this->_db->query($sql);

                if ($result == false)
                    {
                    return false;
                    }
                }

            $sql   ="insert into " . $this->table_prefix
                . "categories
(cat_name,cat_description,cat_parent_id,cat_order)values
('$cat_name','$cat_description','$cat_parent_id','$cat_order')";
            $result=$this->_db->query($sql);

            if ($result == false)
                {
                return false;
                }

            $dest_folder=ROOT_PATH . $GLOBALS['categoryService']->directoryFullPath($this->_db->get_insert_id());

            if (!file_exists($dest_folder))
                {
                if (!mkdir($dest_folder, 0777))
                    {
                    return false;
                    }
                }
            }
        else
            {
            return false;
            }

        return true;
        }

    public function update($data)
        {
        $cat_id         =$data['id'];
        $cat_name       =$data['name'];
        $cat_description=$data['description'];

        $dest_folder    =ROOT_PATH . $GLOBALS['categoryService']->directoryFullPath($cat_id);
        $newName        =dirname($dest_folder) . '/' . $cat_name;

        if(is_dir($dest_folder))
        {
        if (!rename($dest_folder, $newName))
            {
            return false;
            }
        }else
        {
            return false;
        }

        $sql   ="update " . $this->table_prefix . "categories set " . "cat_name='$cat_name',"
            . "cat_description='$cat_description'" . "where cat_id='$cat_id'";
        $result=$this->_db->query($sql);

        if ($result == false)
            {
            return false;
            }

        return true;
        }

    public function changeOrder($data)
        {
        $cat_id=$data['id'];
        $move  =$data['move'];

        if ($move == "down")
            {
            $sql   ="select cat_id from " . $this->table_prefix
                . "categories where cat_parent_id = (select cat_parent_id from " . $this->table_prefix
                . "categories where cat_id=$cat_id) and cat_order = (select cat_order from " . $this->table_prefix
                . "categories where cat_id=$cat_id) + 1";
            $result=$this->_db->query($sql);
            $temp  =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
            $this->_db->free_result($result);

            if (!is_null($temp['cat_id']))
                {
                $sql   ="update " . $this->table_prefix . "categories set cat_order=cat_order-1 where cat_id="
                    . $temp['cat_id'];
                $result=$this->_db->query($sql);
                $sql   ="update " . $this->table_prefix . "categories set cat_order=cat_order+1 where cat_id="
                    . $cat_id;
                $result=$this->_db->query($sql);
                }
            }
        else if ($move == "up")
            {
            $sql   ="select cat_id from " . $this->table_prefix
                . "categories where cat_parent_id = (select cat_parent_id from " . $this->table_prefix
                . "categories where cat_id=$cat_id) and cat_order = (select cat_order from " . $this->table_prefix
                . "categories where cat_id=$cat_id) - 1";
            $result=$this->_db->query($sql);
            $temp  =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
            $this->_db->free_result($result);

            if (!is_null($temp['cat_id']))
                {
                $sql   ="update " . $this->table_prefix . "categories set cat_order=cat_order+1 where cat_id="
                    . $temp['cat_id'];
                $result=$this->_db->query($sql);
                $sql   ="update " . $this->table_prefix . "categories set cat_order=cat_order-1 where cat_id="
                    . $cat_id;
                $result=$this->_db->query($sql);
                }
            }
        }

    public function del($catId)
        {
        $sql   ="select cat_id from " . $this->table_prefix . "categories where cat_parent_id = (select 

cat_parent_id from " . $this->table_prefix . "categories where cat_id=$catId) and cat_order > (select cat_order 

from " . $this->table_prefix . "categories where cat_id=$catId)";
        $result=$this->_db->query($sql);
        $ids   =$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);

        foreach ($ids as $id)
            {
            $sql   = "update " . $this->table_prefix . "categories set cat_order=cat_order-1 where 

cat_id='" . $id['cat_id'] . "'";
            $result=$this->_db->query($sql);
            }

        $dest_folder=ROOT_PATH . $GLOBALS['categoryService']->directoryFullPath($catId);
        if(is_dir($dest_folder))
        {
          $this->delDir($dest_folder);
        }
        $this->delItemInTable($catId);
        }

    private function delItemInTable($catId)
        {
        $sql       ="delete from " . $this->table_prefix . "categories where cat_id = '$catId'";
        $result    =$this->_db->query($sql);
        $sql       ="delete from " . $this->table_prefix . "images where cat_id = '$catId'";
        $result    =$this->_db->query($sql);

        $categories=$GLOBALS['categoryService']->listCategories($catId);

        foreach ($categories as $index => $category)
            {
            $this->delItemInTable($category['cat_id']);
            }
        }

    public function delDir($dir)
        {
        $handle=opendir($dir);

        while ($file=readdir($handle))
            {
            if ($file != "." && $file != "..")
                {
                $fullpath=$dir . $file;

                if (is_dir($fullpath))
                    {
                    $this->delDir($fullpath . "/");
                    }
                else
                    {
                    unlink ($fullpath);
                    }
                }
            }

        closedir ($handle);
        rmdir ($dir);
        }

    public function getDirSize($dir)
        {
        $sizeResult=0;
        $handle    =opendir($dir);

        while ($file=readdir($handle))
            {
            if ($file != "." && $file != "..")
                {
                $fullpath=$dir . $file;

                if (is_dir($fullpath))
                    {
                    $sizeResult+=$this->getDirSize($fullpath . "/");
                    }
                else
                    {
                    $sizeResult+=filesize($fullpath);
                    }
                }
            }

        closedir ($handle);
        return $sizeResult;
        }

    public function listCategories($pcatId)
        {
        $sql    ="select cat_id, cat_name from " . $this->table_prefix . "categories where cat_parent_id=" . $pcatId
            . " order by cat_order";
        $result =$this->_db->query($sql);
        $catList=$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $catList;
        }

    public function directoryFullPath($catId)
        {
        if ($catId == 1)
            {
            return DATA_PATH;
            }
        else
            {
            $dirname      =$this->searchNameById($catId);
            $parentId     =$this->searchParentIdById($catId);
            $parentDirPath=$this->directoryFullPath($parentId);
            return $parentDirPath . $dirname . "/";
            }
        }

    public function searchById($catId)
        {
        $sql     ="select * from " . $this->table_prefix . "categories where cat_id=" . $catId;
        $result  =$this->_db->query($sql);
        $category=$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $category;
        }

    private function searchNameById($catId)
        {
        $sql   ="select cat_name from " . $this->table_prefix . "categories where cat_id=" . $catId;
        $result=$this->_db->query($sql);
        $id    =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $id['cat_name'];
        }

    private function searchParentIdById($catId)
        {
        $sql   ="select cat_parent_id from " . $this->table_prefix . "categories where cat_id=" . $catId;
        $result=$this->_db->query($sql);
        $id    =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $id['cat_parent_id'];
        }

    private function pcategoryContainName($pid, $name)
        {
        $sql="select * from " . $this->table_prefix . "categories where cat_parent_id=" . $pid . " and 

cat_name='" . $name . "'";
        return $this->_db->not_empty($sql);
        }
    }
?>